/*                                                     project Gemini 
----------------------------------------------------------------------
   Graphical EM Core Module
      $Id: gem.h,v 1.3 2002/11/21 13:52:59 abe Exp $

       Copyright (C) 2001-2002, SATO Lab. <http://mi.cs.titech.ac.jp> 
----------------------------------------------------------------------
*/
#ifndef _GEM_H_20020319Tue_152017_
#define _GEM_H_20020319Tue_152017_

#include "ruby.h"


/* l^ */
typedef  double  real_t;

/* Ruby Array \ */
typedef  struct RArray *  RArray_p;


/* OtBJ EM */
struct tagGraphicalEM
{
    VALUE paramtbl;   /* Hash:  --> p[^CfNX */
    VALUE paramary;   /* Array: p[^CfNX -->  */
    VALUE sgary;      /* Array: gpxOt̃Xg */
    
    int     problen;  /* Sp[^ (emsw̃XCb`v) */
    int*    swary;    /* emsw̃XCb`̃Xg */
    int     swlen;    /* msw */
    real_t* probtbl;  /* gEM Ŏgmp[^ */
    real_t* xnumtbl;  /*             ғKp */
};
typedef  struct tagGraphicalEM  GraphicalEM;


struct tagSG_Graph;
struct tagSG_Path;
struct tagSG_Node;
typedef  struct tagSG_Graph  SG_Graph;
typedef  struct tagSG_Path  SG_Path;
typedef  struct tagSG_Node  SG_Node;

/* xOt: m[h */
struct tagSG_Node
{
    union {
        struct Indirect /* ԐڎQƔ */
        {
            int type; /* type=0: f[^ */
            union
            {
                int       sw;    /* type=1: {m[h (CfNX) */
                SG_Graph* graph; /* type=2: Ot */
                VALUE     obj;   /* type=3: {m[h */
            } data;
        } ind;
        struct Direct /* ڎQƔ */
        {
            real_t*  i_ptr;    /* Inside vZ */
            real_t*  o_ptr;    /* Outside vZ */
            real_t*  o_inside; /* Outside vZ */
        } dir;
    } d;
};

/* xOt: pX */
struct tagSG_Path
{
    SG_Node  *nodeary;
    int       nodelen;
    real_t    inside;
};

/* xOt: Ot */
struct tagSG_Graph
{
    SG_Path  *pathary;
    int       pathlen;
    real_t    inside, outside;
    
    void  *ext; /* ǉf[^ */
};

/* xOt */
struct tagSupportGraph
{
    int  size_graph;
    int  size_path;
    int  size_node;
    
    SG_Graph* buffer_graph;
    SG_Path*  buffer_path;
    SG_Node*  buffer_node;
    
    void  *ext_graph; /* ǉf[^p̃obt@ */
    
    /* Zpf[^ */
    GraphicalEM* owner_gem;
};
typedef struct tagSupportGraph SupportGraph;


/* C^[tFCX */
void Init_gem ( void );

/** @brief xOt̃RpC
 *
 * ԐڎQƂ̎xOtRpCAڎQƔłɂ܂B
 * łɃRpCꂽxOtnꂽꍇAO RuntimeError ܂B
 * 
 * @param sg [i/o] RpCxOt
 * @param gem [in] QƂɎg gEM IuWFNg
 * @return RpCꂽxOt
 */
SupportGraph* sgraph_compile ( SupportGraph* sg, GraphicalEM* gem );

/** @brief m[hɑΉ镶擾
 *
 * m[hɑΉ镶擾܂B
 * ʂ buffer ɃRs[܂Bbuffer ͏\ʂmۂĂ悤ɂĂB
 *
 * @param buffer [i/o] KvȂƂɎg镶p̃obt@
 * @param gem [in] graphical EM IuWFNg
 * @param sg [in] m[hxOtIuWFNg
 * @param node [in] m[hIuWFNg
 * @return buffer 瑱k̈ʒu|C^
 */
char * node_string ( char * buffer, GraphicalEM const * gem, SupportGraph const * sg, SG_Node const * node );

/** @brief w肳ꂽCfNX̃p[^擾
 *
 * w肳ꂽCfNX̃p[^擾܂B
 * ͈͊ÕCfNXnꂽꍇANULL Ԃ܂B
 *
 * @param gem [in] graphical EM IuWFNg
 * @param id [in] 擾p[^̃CfNX
 * @return p[^
 * @retval NULL w肳ꂽCfNX݂͑Ȃ
 */
const char * gem_param_at ( GraphicalEM const * gem, int id );


/*   xOtRpCĂ邩𒲂ׂ
------------------------------------------------------------------- */
#define sgraph_compiled_p(SGPTR)  ((SGPTR)->owner_gem != NULL)


#endif /* _GEM_H_20020319Tue_152017_ */
