/*                                                     project Gemini 
----------------------------------------------------------------------
    Earley p[U
      $Id: eparser.h,v 1.1 2002/10/16 05:07:48 abe Exp $

       Copyright (C) 2001-2002, SATO Lab. <http://mi.cs.titech.ac.jp> 
----------------------------------------------------------------------
*/
/** @file
 * @brief Earley p[U (wb_)
 *
 * Earley p[U`wb_t@CłB
 * 
 * @author ABE Shigeru
 * @date 2002/10/13
 * $Revision: 1.1 $
 */
#ifndef _EPARSER_H_20021013Sun_194942_
#define _EPARSER_H_20021013Sun_194942_

#include "chart.h"

/** @brief Earley p[U
 *
 * Earley p[UgIuWFNgB
 */
struct tagEParser
{
    /** @brief Ruby IuWFNg
     *
     * gɑΉ Ruby IuWFNgłB
     */
    VALUE self_object;
    
    /** @brief FIRST W
     *
     * grammar ɑΉ FIRST WłB
     */
    FIRSTSet*  firstset;
    
    /** @brief @
     *
     * gp镶@łB
     */
    Grammar*  grammar;
    
    /** @brief JnL
     *
     * \͂̎ɎgpJnLłB
     */
    VALUE  start;
};
typedef  struct tagEParser  EParser;


/** @brief \͑Ώۃf[^
 *
 * \͂̑ΏۂɂȂ镔؃IuWFNgłB
 */
struct tagTree
{
    /** @brief ؃gbvx
     *
     * ̕؂̃gbv܂B
     * x̃f[^ɕtĂȂꍇA̒l NULL ɂȂ܂B
     * Xg͒l 0 I[ɂȂ܂B
     */
    int*  label;
    
    /** @brief ؂̍[ʒu
     *
     * ̕؂̍[ʒu܂B
     */
    int  left;
    
    /** @brief ؂̉E[ʒu
     *
     * ̕؂̉E[ʒu܂B
     */
    int  right;
    
    /** @brief qؐ
     *
     * ̕؂ۗLq؂̐܂B
     */
    int  child_len;
    
    /** @brief q؃Xg
     *
     * q؂ւ̃Xg܂B
     * ̒l NULL ̂Ƃ͎q؂݂ȂAȂ킿؂̖[ł邱Ƃ܂B
     * ȂAXg̏I[ NULL |C^ɂȂĂ܂B
     */
    struct tagTree* * child_ary;
    
    /** @brief Prediction Ŏgp郉x
     *
     * Prediction ɓBƂĎgp郉x܂B
     */
    int*  prediction_label;
};
typedef  struct tagTree  Tree;


/** @brief \̓f[^
 *
 * \͗p̃f[^IuWFNgB
 */
struct tagParseData
{
    /** @brief Ruby IuWFNg
     *
     * gɑΉ Ruby IuWFNgłB
     */
    VALUE self_object;
    
    /** @brief gpp[UIuWFNg
     *
     * gpp[UIuWFNg܂B
     */
    EParser* parser;
    
    /** @brief gpĂ`[g
     *
     * ݂̍\͂ŎgpĂ`[gIuWFNgłB
     */
    Chart* chart;
    
    /** @brief Prediction pe[u
     *
     * Prediction ŗpe[uBPrediction Lɂ͐^܂B
     * ȂAY͎q̈ʒułÄʒuł͂Ȃ̂Œӂ邱ƁB
     */
    int** pred_table;
    
    /** @brief \͑Ώە
     *
     * \͂̑ΏۂƂȂ Tree IuWFNg܂B
     */
    Tree* tree;
    
    /** @brief L[̐擪
     *
     * L[̐擪߂̃|C^łB
     * NULL ̏ꍇAL[ł邱Ƃ܂B
     */
    State* queue_head;
    
    /** @brief L[̖
     *
     * L[̖߂̃|C^łB
     * queue_top ƓANULL ̏ꍇ̓L[ł邱Ƃ܂B
     */
    State* queue_tail;
};
typedef  struct tagParseData  ParseData;


/** @brief p[UIuWFNg̉
 *
 * nꂽ Earley p[UIuWFNgj܂B
 *
 * @param ptr [in] p[UIuWFNg
 */
void eparser_free ( EParser* ptr );

/** @brief p[UIuWFNg̃}[N
 *
 * nꂽp[UIuWFNgɑ΂ăKx[WRN^p̃}[Ns܂B
 *
 * @param ptr [in] }[NIuWFNg
 */
void eparser_mark ( EParser* ptr );

/** @brief f[^IuWFNg̉
 *
 * nꂽf[^IuWFNgƂ̓ej܂B
 * A`[gIuWFNgɊւĂ͉܂B
 *
 * @param ptr [in] f[^IuWFNg
 */
void parsedat_free ( ParseData* ptr );

/** @brief f[^IuWFNg̃}[N
 *
 * nꂽf[^IuWFNgɑ΂ăKx[WRNgp̃}[Ns܂B
 *
 * @param ptr [in] }[NIuWFNg
 */
void parsedat_mark ( ParseData* ptr );

/** @brief f[^IuWFNg̐
 *
 * \͗p̃f[^IuWFNg𐶐܂B
 * f[^IuWFNgۗL`[gIuWFNgɐ܂B
 *
 * @param parent [in] f[^̌pIuWFNg
 * @param tree [in] \͂\؃IuWFNg
 * @return ꂽf[^IuWFNg
 */
VALUE parsedat_new ( EParser* parser, Tree* tree );

/** @brief ͕IuWFNg̐
 *
 * ͕f[^IuWFNg𐶐܂B
 *
 * @param treetop [in] ͕ Ruby IuWFNg (WordTree)
 * @return ꂽ͕IuWFNg
 */
Tree* tree_new ( VALUE treetop );

/** @brief ͕IuWFNg̉
 *
 * ͕f[^IuWFNg̃̈܂B
 * q؂ׂĉ܂B
 *
 * @param ptr [i/o] ͕IuWFNg
 */
void tree_free ( Tree* ptr );

/** @brief \
 *
 * Ext::EarleyParser#parse() ɑ܂B
 *
 * Earley p[Ugpė^ꂽ\͂܂B
 * \͂\Ȃ̂ WordTree IuWFNĝ݂łB
 *
 * @param self [in] Earley p[UIuWFNg
 * @param wordtree [in] \͂̑Ώ
 * @return \͌ʂƂȂ`[gIuWFNg
 */
VALUE eparser_parse ( VALUE self, VALUE wordtree );

#endif /* _EPARSER_H_20021013Sun_194942_ */
