/*                                                     project Gemini 
----------------------------------------------------------------------
    Earley pR[h
      $Id: item.c,v 1.8 2002/09/17 07:55:01 abe Exp $

       Copyright (C) 2001-2002, SATO Lab. <http://mi.cs.titech.ac.jp> 
----------------------------------------------------------------------
*/
#define DEBUGSW 0
#include "nlputil.h"


/*   ̎擾
------------------------------------------------------------------- */
Grammar* item_get_grammar ( Item_p item )
{
    Grammar* gram;
    
    if( !item || !item->rule )
        return NULL;
    
    Data_Get_Struct( item->rule->gramobj, Grammar, gram );
    
    return gram;
}


/* ڂ̕\ (fobOp)
------------------------------------------------------------------- */

Item * item_display ( Item * item )
{
    VALUE  ts;
    int    i;
    
    if( item && item->rule ) {
        ts = rb_funcall(item->rule->ruleobj, id_typestring, 1, INT2FIX(item->dot) );
        fprintf( stderr, "(%d,%d)<Rule#{%d} %s>\n", item->left, item->right, item->rule->id, STR2CSTR(ts) );
    }
    else {
        if( !item )
            fprintf( stderr, "[NULL]\n" );
        else
            fprintf( stderr, "[Broken Item]\n" );
    }
    
    return item;
}

Item * item_display2 ( const char * header, Item * item )
{
    fprintf( stderr, header );
    return item_display( item );
}

VALUE  item_inspect  ( Item * item )
{
    Grammar*  gram;
    char   buf[1024];
    char  *p = buf;
    
    if( item->rule ) {
        sprintf( p, "(%d,%d)[ Rule#%d: ", item->left, item->right, item->rule->id );
        p += strlen( p );
        
        rule_typestring_internal( item->rule, p, item->dot );
        p += strlen( p );
        
        sprintf( p, " ]" );
    }
    else {
        sprintf( p, "(%d,%d) %s", item->left, item->right, cfg_getcatname( item_get_grammar(item), item->top ) );
    }
    
    return rb_str_new2( buf );
}


/*   V Earley 쐬
------------------------------------------------------------------- */

Item * item_reset ( Item * item, Rule * r, int left, int right, int dot )
{
    if( !item )
        return NULL;
    
    item->rule  = r;
    item->top   = r->lhs;
    item->dot   = dot;
    item->left  = left;
    item->right = right;
    item->tag   = 0;
    item->data  = NULL;
    
    return item;
}

Item * item_new ( Rule * r, int left, int right, int dot )
{
    return item_reset( ALLOC( Item ), r, left, right, dot );
}


/*   ̏o͂
------------------------------------------------------------------- */

int item_print_label ( char* buf, Grammar* gram, Item* item )
{
    VALUE cat;
    
    cat = rb_String( cfg_get_category( gram, item->top ) );
    
    /* o͂oCgԂ */
    return sprintf( buf, "%s (%d, %d)", RSTRING(cat)->ptr, item->left, item->right );
}


