/*                                                     project Gemini 
----------------------------------------------------------------------
    Rꏈ [eBeB gW[
      $Id: nlputil.h,v 1.22 2002/10/16 05:09:07 abe Exp $

       Copyright (C) 2001-2002, SATO Lab. <http://mi.cs.titech.ac.jp> 
----------------------------------------------------------------------
*/
#ifndef _NLPUTIL_20011111Sun_090920_
#define _NLPUTIL_20011111Sun_090920_

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <math.h>

#include "rubytool.h"

#undef EXTERN
#ifdef DEFINE_BODY
#define EXTERN
#else
#define EXTERN extern
#endif


/*   ^
------------------------------------------------------------------- */
typedef  double  real_t;


/*   fobOR[h
------------------------------------------------------------------- */
#if DEBUGSW

#undef  Dputs
#undef  Dprintf
#undef  Dcom

#define Dputs(STR) fputs( STR, stderr )
#define Dprintf(STR,V) fprintf( stderr, STR, V )
#define Dcom(COM) (COM)

#else

#define Dputs(STR)
#define Dprintf(STR,V)
#define Dcom(COM)

#endif

int errp ( const char * format, ... );
int defp ( const char * format, ... );


/* CN[h: @ */
#include "grammar.h"
#include "pcfg.h"


/* CN[h: `[g\ */
#include "chart.h"


/* CN[h: Earley p[U */
#include "eparser.h"


/* CN[h: \͌ */
#include "itemset.h"


/* CN[h:  */
#include "strparse.h"


/*   O[oϐ
------------------------------------------------------------------- */
extern VALUE rb_mExt;
extern VALUE rb_cGrammar;
extern VALUE rb_eNLPException;

extern ID id_id;
extern ID id_plus;
extern ID id_mult;
extern ID id_size;
extern ID id_last;
extern ID id_first;
extern ID id_length;
extern ID id_typestring;


/*   vg^Cv錾
------------------------------------------------------------------- */

/* item.c */
Item * item_new      ( Rule * r, int left, int right, int dot );
Item * item_reset    ( Item * item, Rule * r, int left, int right, int dot );
Item * item_display  ( Item * item );
Item * item_display2 ( const char * header, Item * item );
VALUE  item_inspect  ( Item * item );

Grammar* item_get_grammar ( Item_p item );

int item_print_label ( char* buf, Grammar* gram, Item* item );


/*   Ruby f[^p[eBeB
------------------------------------------------------------------- */
#define ru_at(ary,pos) rb_funcall(ary,id_at,1,INT2FIX(pos))
#define ru_id(obj) NUM2INT(rb_funcall(obj,id_id,0))
#define ru_size(obj) NUM2INT(rb_funcall(obj,id_size,0))
#define ru_length(obj) NUM2INT(rb_funcall(obj,id_length,0))
#define ru_first(obj) rb_funcall(obj,id_first,0)
#define ru_last(obj) rb_funcall(obj,id_last,0)
#define ru_rhs(obj) rb_funcall(obj,id_rhs,0)
#define ru_lhs(obj) rb_funcall(obj,id_lhs,0)
#define ru_compiled_p(obj) RTEST(rb_funcall(obj,id_compiled_p,0))

int ru_is_instance_of ( VALUE obj, VALUE klass );


/*   gp֐p̃XCb`
----------------------------------------------------------------------
SAFE_sprintf
   ^̏ꍇ _snprintf gASEGV NȂ悤ɂB
   }NŃR[hu킯ł͂Ȃ̂ŁAׂăvO}
snprintf gĂ镔Ã}N _snprintf g
悤ɎȂ΂ȂȂB

ARYSIZE(N)
   ϐzTCY𓾂B
*/
#define SAFE_sprintf 1
#define ARYSIZE(V) (sizeof((V))/sizeof((V)[0]))


#endif /* _NLPUTIL_20011111Sun_090920_ */
