/*                                                     project Gemini 
----------------------------------------------------------------------
    Stolcke ̃ASY
      $Id: stolcke.c,v 1.15 2002/12/03 09:54:16 abe Exp $

       Copyright (C) 2001-2002, SATO Lab. <http://mi.cs.titech.ac.jp> 
----------------------------------------------------------------------
*/
/** @file
 * @brief Stolcke ̃ASY
 *
 * Stolcke ̃ASY܂B
 * 
 * @author ABE Shigeru
 * @date 2002/10/29
 * $Revision: 1.15 $
 */
#define DEBUG_FREE  0  /**< IuWFNg̃fobOx */
#define DEBUG_MARK  0  /**< GC }[Np̃fobOx */
#define DEBUG_PREDICTION 0 /**< Prediction ̃fobOx */
#define DEBUG_COMPLETION 0 /**< Completion ̃fobOx */
#define DEBUG_SCANNING 0 /**< Scanning ̃fobOx */
#define DEBUG_INNER 0 /**< mvZ̃fobOx */
#define DEBUG_RCOMPLETION 0 /**< Reverse Completion ̃fobOx */
#define DEBUG_PROB_UPDATE 0 /**< mXṼfobOx */
#define DEBUG_PQUEUE 0 /**< L[\̃fobOx */
#include "stolcke.h"
#include "matrix.h"
#include <math.h>

/* ---------------------------------------------------------------- */

VALUE cls_Stolcke_Parser;

VALUE cls_Stolcke_Chart;

VALUE cls_Stolcke_OriginalParser;

VALUE cls_Stolcke_FLQParser;

VALUE cls_Stolcke_FixedParser;

/* ---------------------------------------------------------------- */

/** @brief OmvZ̃C^[tFCX
 *
 * OmvZ֐ɋʂC^[tFCXłB
 *
 * @param parser [in] p[UIuWFNg
 * @param schart [in] `[gIuWFNg
 */
typedef void (* _ProcessOutsideIF) ( StolckeParser * parser, StolckeChart * schart );

/** @brief L[ւ̒ǉ̃C^[tFCX
 *
 * DxtL[ɏԂǉ֐ɋʂC^[tFCXłB
 *
 * @param parser [in] p[UIuWFNg
 * @param queue [i/o] ǉL[IuWFNg
 * @param state [in] ǉ
 */
typedef State * (* _PQueuePushIF) ( StolckeParser * parser, StateQueue * queue, State * state );

/* ---------------------------------------------------------------- */

/** @brief m̌vZ (IWi)
 *
 * IWĩASYɂāA`[gɊւmvZ܂B
 *
 * @param parser [in] gpp[U
 * @param chart [in] vZɎg`[g
 * @return ̐m
 */
static double stolcke_origparser_process_inside ( StolckeParser * parser, StolckeChart * chart );

/** @brief Om̌vZ (IWi)
 *
 * IWĩASYɂāA`[gɊւOmvZ܂B
 *
 * @param parser [in] gpp[U
 * @param chart [in] vZɎg`[g
 */
static void stolcke_origparser_process_outside ( StolckeParser * parser, StolckeChart * chart );

/** @brief Om̌vZ (CE[JL[)
 *
 * C ([JL[gp) ̃ASYɂāA`[gɊւOmvZ܂B
 *
 * @param parser [in] gpp[U
 * @param chart [in] vZɎg`[g
 */
static void stolcke_flqparser_process_outside ( StolckeParser * parser, StolckeChart * chart );

/** @brief Om̌vZ (C)
 *
 * C ([JL[gp) ̃ASYɂāA`[gɊւOmvZ܂B
 *
 * @param parser [in] gpp[U
 * @param chart [in] vZɎg`[g
 */
static void stolcke_fixedparser_process_outside ( StolckeParser * parser, StolckeChart * chart );

/** @brief DxtL[ɒǉ (inside)
 *
 * L[A[ʒu傫̂珇ɎoĂDxtL[ƌȂAɃf[^ǉ܂B
 * ȂÅ֐͒ʏ̃L[֐ƌĎgpĂ͂Ȃ܂B
 *
 * @param queue [i/o] ΏۂƂȂL[
 * @param state [in] ǉ
 * @return ǉꂽ
 */
static State * pqueue_push_inside ( StateQueue * queue, State * state );

/** @brief DxtL[ɒǉ (outside: IWi)
 *
 * L[A[ʒû珇ɎoĂDxtL[ƌȂAɃf[^ǉ܂B
 * ȂÅ֐͒ʏ̃L[֐ƌĎgpĂ͂Ȃ܂B
 *
 * @param parser [in] p[UIuWFNg
 * @param queue [i/o] ΏۂƂȂL[
 * @param state [in] ǉ
 * @return ǉꂽ
 */
static State * pqueue_push_outside_original ( StolckeParser * parser, StateQueue * queue, State * state );

/** @brief DxtL[ɒǉ (outside: CE[JL[)
 *
 * L[DxtL[ƌȂAɃf[^ǉ܂B
 * ȂÅ֐͒ʏ̃L[֐ƌĎgpĂ͂Ȃ܂B
 *
 * @param queue [i/o] ΏۂƂȂL[
 * @param state [in] ǉ
 * @return ǉꂽ
 */
static State * pqueue_push_outside_flq ( StolckeParser * parser, StateQueue * queue, State * state );

/** @brief DxtL[ɒǉ (outside: C)
 *
 * L[DxtL[ƌȂAɃf[^ǉ܂B
 * ȂÅ֐͒ʏ̃L[֐ƌĎgpĂ͂Ȃ܂B
 *
 * @param queue [i/o] ΏۂƂȂL[
 * @param state [in] ǉ
 * @return ǉꂽ
 */
static State * pqueue_push_outside_fixed ( StolckeParser * parser, StateQueue * queue, State * state );


/* ---------------------------------------------------------------- */

/*   fobOp
------------------------------------------------------------------- */

static void DEBUG_display_state ( const char * genre, StolckeParser * parser, State const * state )
{
    Grammar const * grammar = (parser)? parser->grammar: NULL;
    
    fprintf( stderr, "%s %s (in=%g, out=%g)\n",
             genre, state_inspect(state, grammar), stolckestate(state)->inner, stolckestate(state)->outer );
}


/*   vZ⏕
------------------------------------------------------------------- */

static void update_unit_list ( StolckeParser * parser, Matrix const * r )
{
    const int ntsize = cfg_size_nonterm(parser->grammar);
    int  i, j;
    int  *wp;
    double *rp;
    
    /* Xg̍쐬 */
    if( !parser->unit_list ) {
        parser->unit_list = ALLOC_ZERO_N(int*, ntsize + 1);
        parser->unit_list[0] = ALLOC_N(int, (ntsize + 1) * ntsize);
        for( i = 1; i < ntsize; ++i )
            parser->unit_list[i] = &parser->unit_list[0][ (ntsize + 1) * i ];
    }
    for( i = 1; i < ntsize; ++i ) {
        wp = parser->unit_list[i];
        rp = r->m[i];
        for( j = 0; j < ntsize; ++j, ++rp ) {
            if( *rp != 0.0 )
                *(wp++) = j;
        }
        *wp = 0;
    }
}

StolckeParser* update_unit_matrix ( StolckeParser* parser )
{
    const int ntsize = cfg_size_nonterm(parser->grammar);
    
    Rule const * r;
    double * * matrix;
    Matrix  p_u;
    int  i;
    
    /* R_U ̌vZ */
    p_u = matrix_create( ntsize, ntsize );
    for( i = 0; i < ntsize; ++i ) {
        for( r = cfg_hash_lhs(parser->grammar, i); r; r = r->next_lhs ) {
            if( r->rhslen != 1 || r->rhs[0] <= 0 )
                continue;
            p_u.m[r->lhs][r->rhs[0]] = -parser->prob_table[r->id];
        }
        p_u.m[i][i] += 1.0;
    }
    matrix_inverse( &p_u );
    
    matrix = parser->unit_matrix;
    if( !matrix ) {
        matrix = parser->unit_matrix = ALLOC_N(double*, ntsize + 1);
        for( i = 0; i < ntsize; ++i )
            matrix[i] = ALLOC_N(double, ntsize);
        matrix[ntsize] = NULL;
    }
    for( i = 0; i < ntsize; ++i )
        memcpy( matrix[i], p_u.m[i], ntsize * sizeof(double) );
    
    update_unit_list( parser, &p_u );
    
    matrix_free( &p_u );
    
    return parser;
}

double * create_prob_table ( PCFG* pcfg )
{
    Grammar*  grammar;
    double*  ret;
    int  rulesize;
    int  i;
    
    Data_Get_Struct( pcfg->gramobj, Grammar, grammar );
    rulesize = cfg_size_rule(grammar);
    ret = ALLOC_N(double, rulesize );
    for( i = 0; i < rulesize; ++i ) {
        ret[i] = pcfg_get_rule_probability( pcfg, i );
    }
    
    return ret;
}

/*   `[gIuWFNg
------------------------------------------------------------------- */

void stolckechart_mark ( StolckeChart* ptr )
{
    #if DEBUG_MARK > 0
    fprintf( stderr, "[MARK] stolckechart_mark(): begin.\n" );
    #endif
    if( ptr ) {
        if( ptr->chart )
            rb_gc_mark( ptr->chart->self_object );
    }
    #if DEBUG_MARK > 0
    fprintf( stderr, "[MARK] stolckechart_mark(): end.\n" );
    #endif
}

static void stolckechart_free ( StolckeChart* ptr )
{
    if( ptr ) {
        ruby_xfree( ptr->state_buffer );
        ruby_xfree( ptr );
    }
}

void stolcke_chart_alloc_data ( StolckeChart * schart )
{
    Chart * chart = schart->chart;
    State * ptr;
    int  count;
    int  i;
    
    count = chart_count_item( schart->chart );
    
    schart->state_buffer = ALLOC_N(StolckeState, count);
    
    count = 0;
    for( i = chart->left; i <= chart->right; ++i ) {
        for( ptr = chart_dot( chart, i ); ptr; ptr = ptr->next_dot )
            ptr->data = &schart->state_buffer[count++];
    }
}

VALUE stolcke_chart_new ( StolckeParser* parser, ItemSet const * itemset )
{
    StolckeChart * schart;
    VALUE volatile chartobj;
    VALUE volatile obj;
    Chart * chart;
    
    if( parser->grammar != itemset->grammar )
        rb_raise( rb_eRuntimeError, "given different grammar between parser and itemset" );
    
    /* `[g\͌ʂ畜āc */
    chartobj = itemset_reconstruct_chart( itemset );
    Data_Get_Struct( chartobj, Chart, chart );
    chart_mark_start_state( chart );
    
    /* ǉf[^̈pӂĊ蓖Ă */
    schart = ALLOC_ZERO_N(StolckeChart, 1);
    obj = Data_Wrap_Struct( cls_Stolcke_Chart, stolckechart_mark, stolckechart_free, schart );
    schart->chart = chart;
    stolcke_chart_alloc_data( schart );
    
    return obj;
}

static int stolcke_chart_memsize ( StolckeChart * schart )
{
    int  size;
    
    size = chart_memsize( schart->chart );
    size += sizeof(StolckeChart);
    size += sizeof(StolckeState) * chart_count_item( schart->chart );
    
    return size;
}


/*   DxtL[̑
------------------------------------------------------------------- */

/** @brief DxtL[p̃\[g֐
 *
 * DxtL[ŎgpAr֐̃C^[tFCXłB
 *
 * @param s1 [in] r
 * @param s2 [in] r
 * @param param [in] Qlf[^
 * @retval 0 ǂ炪Oł܂Ȃ
 * @retval -1 s1 ̕OɂȂ
 * @retval 1 s1 ̕ɂȂ
 */
typedef int (* pqueue_cmp_func) ( State const * s1, State const * s2, void * param );

/** @brief DxtL[ւ̒ǉ
 *
 * DxtL[ւ̒ǉs܂B
 * ǉꂽڂ̓\[gꂽԂŕт܂B
 *
 * @param queue [i/o] ǉL[
 * @param state [in] ǉ
 * @param func [in] \[gp֐
 * @param param [in] Ql
 * @return ǉꂽ
 */
static State * pqueue_push ( StateQueue * queue, State * state, pqueue_cmp_func func, void * param )
{
    int  mid, left, right;
    
    if( queue->length == 0 )
        return queue_push( queue, state );
    
    if( queue->length == queue->capacity )
        queue_order( queue, queue->length / 2, queue->length / 2 );
    else
        queue_arrange( queue );
    
    left = queue->pos_head;
    right = queue->pos_tail;
    while( left != right ) {
        mid = (right + left) / 2;
        switch( func( state, queue_ref(queue, mid), param ) ) {
        case 0:
        case -1:
            right = mid;
            break;
        case 1:
            left = mid + 1;
            break;
        }
    }
    queue_insert( queue, state, left - queue->pos_head );
    
    return state;
}

/* Inside p */
static int stolckestate_cmp_inside ( State const * s1, State const * s2, void * dummy )
{
    if( s1->left == s2->left )
        return 0;
    
    return (s1->left > s2->left)? -1: 1;
}

static State * pqueue_push_inside ( StateQueue * queue, State * state )
{
    return pqueue_push( queue, state, stolckestate_cmp_inside, NULL );
}

#if 0
#define ENABLED_pqueue_inside_test
#include <stdlib.h>
#include <time.h>

static VALUE stolcke_pqueue_inside_test ( VALUE self )
{
    StolckeParser * parser;
    StateQueue * queue;
    Grammar * grammar;
    State * state;
    char  buf [ 4096 ];
    char * p;
    VALUE v;
    int  count;
    int  size_rule;
    time_t  t;
    
    fprintf( stderr, "stolcke_pqueue_inside_test:\n" );
    
    Data_Get_Struct( self, StolckeParser, parser );
    grammar = parser->grammar;
    
    srand((unsigned)time(&t));
    size_rule = cfg_size_rule( grammar );
    fprintf( stderr, "size_rule = %d\n", size_rule );
    
    queue = queue_init( NULL );
    fprintf( stderr, "[ queue initializing successed ]\n" );
    
    for( count = 1; count <= 200; ++count ) {
        state = ALLOC(State);
        v = cfg_rule_at( grammar, rand() % size_rule );
        Data_Get_Struct( v, Rule, state->rule );
        state->top = state->rule->lhs;
        state->dot = rand() % (state->rule->rhslen + 1);
        do {
            state->left = rand() % 50;
            state->right = rand() % 50;
        } while( state->right < state->left );
        
        pqueue_push_inside( queue, state );
    }
    fprintf( stderr, "\n" );
    queue_display( stderr, queue );
    fprintf( stderr, "[ pqueue_push_inside() finished ]\n" );
    
    for( count = queue->pos_head; count < queue->pos_tail; ++count )
        ruby_xfree( queue_ref(queue, count) );
    
    queue_free( queue );
}
#endif

/* OmEIWi */
static int stolckestate_cmp_outside_original ( State const * s1, State const * s2, void * dummy )
{
    if( s1->left == s2->left )
        return 0;
    
    return (s1->left < s2->left)? -1: 1;
}

static State * pqueue_push_outside_original ( StolckeParser * parser, StateQueue * queue, State * state )
{
    return pqueue_push( queue, state, stolckestate_cmp_outside_original, NULL );
}

static int stolckestate_cmp_range ( State const * s1, State const * s2, void * data )
{
    if( s1->left != s2->left )
        return (s1->left < s2->left)? -1: 1;
    
    if( s1->right != s2->right )
        return (s1->right > s2->right)? -1: 1;
    
    return 0;
}

/** @brief DxtL[ւ̒ǉ (CŌ)
 *
 * DxtL[ւ̒ǉs܂B
 * ǉꂽڂ̓\[gꂽԂŕт܂B
 * ȂÅ֐͏Cł̃ASYpłB
 *
 * @param queue [i/o] ǉL[
 * @param state [in] ǉ
 * @param func [in] \[gp֐
 * @param param [in] Ql
 * @return ǉꂽ
 */
static State * pqueue_push_for_fixed ( StateQueue * queue, State * state, pqueue_cmp_func func, void * param )
{
    State const * ptr;
    int  mid, left, right;
    
    if( queue->length == 0 )
        return queue_push( queue, state );
    
    if( queue->length == queue->capacity )
        queue_order( queue, queue->length / 2, queue->length / 2 );
    else
        queue_arrange( queue );
    
    /* ܂̓TCYł̋Eo */
    left = queue->pos_head;
    right = queue->pos_tail;
    while( left != right ) {
        mid = (right + left) / 2;
        switch( stolckestate_cmp_range( state, queue_ref(queue, mid), param ) ) {
        case -1:
        case 0:
            right = mid;
            break;
        case 1:
            left = mid + 1;
            break;
        }
    }
    
    /* ɏԊł̑}ʒu𔭌 */
    mid = left;
    left = state->left;
    right = state->right;
    for( ; mid < queue_tail(queue); ++mid ) {
        ptr = queue_ref(queue, mid);
        if( ptr->left != left || ptr->right != right || func( state, ptr, param ) < 0 )
            break;
    }
    queue_insert( queue, state, mid - queue->pos_head );
    
    return state;
}

/* OmECE[JL[ */
static int stolckestate_cmp_outside_flq ( State const * s1, State const * s2, void * data )
{
    StolckeParser const * parser = (StolckeParser const *)data;
    int  sym1, sym2;
    int  o1, o2;
    Rule const *r1, *r2;
    
    /* EӍ[gbvɋ߂c */
    r1 = s1->rule;
    r2 = s2->rule;
    if( !r1 || !r2 ) {
        return (!r1)? ((!r2)? 0: -1): 1; /* őɖx]łȁH */
    }
    
    if( r1->rhslen == 1 || r2->rhslen == 1 ) {
        if( r1->rhs[0] > 0 ) {
            if( stolcke_Ru(parser, r1->rhs[0], r2->lhs) > 0 )
                return -1;
        }
        if( r2->rhs[0] > 0 ) {
            if( stolcke_Ru(parser, r2->rhs[0], r1->lhs) > 0 )
                return 1;
        }
    }
    return 0;
}

static State * pqueue_push_outside_flq ( StolckeParser * parser, StateQueue * queue, State * state )
{
    return pqueue_push_for_fixed( queue, state, stolckestate_cmp_outside_flq, parser );
}

/* OmEC */
static int stolckestate_cmp_outside_fixed ( State const * s1, State const * s2, void * data )
{
    StolckeParser const * parser = (StolckeParser const *)data;
    int  sym1, sym2;
    int  o1, o2;
    Rule const *r1, *r2;
    
    /* EӍ[gbvɋ߂c */
    r1 = s1->rule;
    r2 = s2->rule;
    if( !r1 || !r2 )
        return (!r1)? -1: 1; /* őɖx]łȁH */
    
    if( s1->dot == 1 && r1->rhs[0] > 0 ) {
        if( stolcke_Ru(parser, r1->rhs[0], r2->lhs) > 0 )
            return -1;
    }
    if( s2->dot == 1 && r2->rhs[0] > 0 ) {
        if( stolcke_Ru(parser, r2->rhs[0], r1->lhs) > 0 )
            return 1;
    }
    return 0;
}

static State * pqueue_push_outside_fixed ( StolckeParser * parser, StateQueue * queue, State * state )
{
    return pqueue_push_for_fixed( queue, state, stolckestate_cmp_outside_fixed, parser );
}

static void pqueue_display ( FILE * out, StateQueue * queue, StolckeParser * parser )
{
    State const * state;
    Rule const * rule;
    int  i;
    
    fprintf( out, "+-- [StateQueue: %p] (prioritized)\n", queue );
    for( i = queue->pos_head; i != queue->pos_tail; ++i ) {
        if( i == queue->capacity )
            i = 0;
        state = queue_ref(queue, i);
        rule = state->rule;
        
        fprintf( out, "| %s\n", state_inspect(state, parser->grammar) );
    }
    fprintf( out, "+-------\n" );
}


/*   p[UIuWFNg ()
------------------------------------------------------------------- */

static void stolckechart_prediction ( StolckeParser * parser, StolckeChart * schart )
{
    Chart * chart = schart->chart;
    State * ptr;
    Rule const * rule;
    int  i;
    
    for( i = chart->left; i <= chart->right; ++i ) {
        for( ptr = chart_dot(chart, i); ptr; ptr = ptr->next_dot ) {
            if( ptr->dot == 0 ) {
                rule = ptr->rule;
                if( rule )
                    stolckestate(ptr)->inner = parser->prob_table[ rule->id ];
                else
                    stolckestate(ptr)->inner = 1.0;
                #if DEBUG_PREDICTION > 0
                fprintf( stderr, "[PRED] %s (%g)\n", state_inspect(ptr, parser->grammar), stolckestate(ptr)->inner );
                #endif
            }
        }
    }
}

static void stolckechart_init_inner ( StolckeChart * schart )
{
    Chart * chart = schart->chart;
    State * state;
    int  i;
    
    for( i = chart->left; i <= chart->right; ++i ) {
        for( state = chart_dot(chart, i); state; state = state->next_dot ) {
            stolckestate(state)->inner = 0.0;
        }
    }
}

double stolckechart_probability ( StolckeChart const * schart )
{
    Chart * chart = schart->chart;
    State * state;
    double  p = 0.0;
    int  start;
    
    start = category_int( chart->start );
    
    /* JnLgbvɎSJo[鍀΂ OK */
    for( state = chart_comp( chart, chart->left, chart->right ); state; state = state->next_comp ) {
        if( state->top != start )
            continue;
        p += stolckestate(state)->inner;
    }
    
    return p;
}

static void stolckechart_init_outer ( StolckeChart * schart )
{
    Chart * chart = schart->chart;
    State * state;
    int  i;
    int  start;
    
    start = category_int( chart->start );
    
    /* SĂ 0.0 ŏĂc */
    for( i = chart->left; i <= chart->right; ++i ) {
        for( state = chart_dot(chart, i); state; state = state->next_dot ) {
            stolckestate(state)->outer = 0.0;
        }
    }
    
    /* JnL̂Ƃ낾 1.0 ŏĂ (Stolcke ̘_ɂ͂Ȃǁc) */
    for( state = chart_comp( chart, chart->left, chart->right ); state; state = state->next_comp ) {
        if( state->top != start )
            continue;
        stolckestate(state)->outer = 1.0;
    }
}

static void stolckechart_sum_expectation ( StolckeChart * schart, double * xtable )
{
    Chart * chart = schart->chart;
    State * state;
    Rule const * rule;
    double prob = stolckechart_probability( schart );
    int  i;
    
    for( i = chart->left; i <= chart->right; ++i ) {
        for( state = chart_dot(chart, i); state; state = state->next_dot ) {
            if( state->dot == 0 ) {
                rule = state->rule;
                if( rule ) {
                    xtable[rule->id] += stolckestate(state)->inner * stolckestate(state)->outer / prob;
                }
            }
        }
    }
}

/*   p[UIuWFNg ()
------------------------------------------------------------------- */

static void stolcke_free_unit_matrix ( double * * ptr )
{
    int  i;
    
    if( ptr ) {
        for( i = 0; ptr[i]; ++i )
            ruby_xfree( ptr[i] );
        ruby_xfree( ptr );
    }
}

static void stolcke_free_unit_list ( int * * ptr )
{
    if( ptr ) {
        ruby_xfree( ptr[0] );
        ruby_xfree( ptr );
    }
}

static void stolcke_mark ( StolckeParser* ptr )
{
    #if DEBUG_MARK > 0
    fprintf( stderr, "[MARK] stolcke_mark(): begin.\n" );
    #endif
    if( ptr ) {
        if( ptr->grammar )
            rb_gc_mark( ptr->grammar->ruby_object );
        rb_gc_mark( ptr->chart_ary );
    }
    #if DEBUG_MARK > 0
    fprintf( stderr, "[MARK] stolcke_mark(): end.\n" );
    #endif
}

static void stolcke_free ( StolckeParser* ptr )
{
    int  i;
    
    #if DEBUG_FREE > 0
    fprintf( stderr, "[FREE] stolcke_free(): begin.\n" );
    #endif
    if( ptr ) {
        ruby_xfree( ptr->prob_table );
        queue_free( ptr->queue );
        stolcke_free_unit_matrix( ptr->unit_matrix );
        stolcke_free_unit_list( ptr->unit_list );
    }
    #if DEBUG_FREE > 0
    fprintf( stderr, "[FREE] stolcke_free(): end.\n" );
    #endif
}

VALUE stolcke_parser_new ( VALUE klass, VALUE pcfgobj )
{
    StolckeParser*  parser;
    VALUE volatile obj;
    
    parser = ALLOC_ZERO_N( StolckeParser, 1 );
    obj = Data_Wrap_Struct( klass, stolcke_mark, stolcke_free, parser );
    rb_obj_call_init( obj, 1, &pcfgobj );
    
    return obj;
}

static VALUE stolcke_parser_initialize ( VALUE self, VALUE pcfgobj )
{
    StolckeParser*  parser;
    Grammar*  grammar;
    PCFG*  pcfg;
    int  ntsize;
    
    if( CLASS_OF(pcfgobj) != rb_cPCFG )
        rb_raise( rb_eArgError, "requires Ext::PCFG (given %s)", rb_class2name(CLASS_OF(pcfgobj)) );
    Data_Get_Struct( self, StolckeParser, parser );
    Data_Get_Struct( pcfgobj, PCFG, pcfg );
    Data_Get_Struct( pcfg->gramobj, Grammar, grammar );
    
    parser->ruby_object = self;
    parser->grammar = grammar;
    parser->chart_ary = rb_ary_new();
    parser->prob_table = create_prob_table( pcfg );
    parser->queue = queue_init( NULL );
    
    return self;
}

static VALUE stolcke_parser_store ( VALUE self, VALUE itemsetobj )
{
    VALUE volatile chartobj;
    StolckeParser *  parser;
    StolckeChart * schart;
    ItemSet*  itemset;
    int  start;
    
    Data_Get_Struct( self, StolckeParser, parser );
    
    /* o^ł̂ ItemSet  */
    if( CLASS_OF(itemsetobj) != rb_cItemSet )
        rb_raise( rb_eArgError, "requires Ext::ItemSet (given %s)", rb_class2name(CLASS_OF(itemsetobj)) );
    Data_Get_Struct( itemsetobj, ItemSet, itemset );
    
    /* `[g̐Ɠo^ */
    chartobj = stolcke_chart_new( parser, itemset );
    rb_ary_push( parser->chart_ary, chartobj );
    Data_Get_Struct( chartobj, StolckeChart, schart );
    
    return self;
}

static VALUE stolcke_parser_likelihood_m ( VALUE self )
{
    rb_raise( rb_eNotImpError, "use subclass" );
    return self;
}

static VALUE stolcke_parser_update_m ( VALUE self )
{
    rb_raise( rb_eNotImpError, "use subclass" );
    return self;
}

static void stolcke_update_ruleprob ( StolckeParser * parser, double * xtable )
{
    Grammar const * grammar = parser->grammar;
    Rule const * rule;
    double sum;
    int  nonterm;
    int  i, id;
    
    nonterm = cfg_size_nonterm(grammar);
    for( i = 1; i < nonterm; ++i ) {
        sum = 0.0;
        for( rule = cfg_hash_lhs(grammar, i); rule; rule = rule->next_lhs )
            sum += xtable[ rule->id ];
        
        if( sum != 0.0 ) {
            for( rule = cfg_hash_lhs(grammar, i); rule; rule = rule->next_lhs ) {
                id = rule->id;
                
                #if DEBUG_PROB_UPDATE > 0
                {
                    double prev = parser->prob_table[id];
                    double after;
                    char buf [ 4096 ];
                    char * p;
                #endif
                
                parser->prob_table[ id ] = xtable[ id ] / sum;
                
                #if DEBUG_PROB_UPDATE > 0
                    after = parser->prob_table[id];
                    if( prev != after && after != 0 ) {
                        p = buf;
                        p = rule_typestring_internal(rule, p, -1);
                        sprintf( p, " : %g --> %g\n", prev, after );
                        fprintf( stderr, buf );
                    }
                }
                #endif
            }
        }
    }
}

static VALUE stolcke_parser_get_parameter ( VALUE self )
{
    StolckeParser * parser;
    Grammar * grammar;
    VALUE volatile pcfgobj;
    PCFG * pcfg;
    int  rulesize;
    int  i;
    
    Data_Get_Struct( self, StolckeParser, parser );
    grammar = parser->grammar;
    pcfgobj = pcfg_create( grammar->ruby_object );
    Data_Get_Struct( pcfgobj, PCFG, pcfg );
    
    rulesize = cfg_size_rule( grammar );
    for( i = 0; i < rulesize; ++i ) {
        pcfg_store_rule( pcfg, cfg_get_rule( grammar, i ), parser->prob_table[i] );
    }
    
    return pcfgobj;
}

static VALUE stolcke_parser_display_inside ( VALUE self, VALUE out )
{
    StolckeParser * parser;
    StolckeChart * chart;
    VALUE * chart_ptr;
    char  buffer [ 4096 ];
    double  sentprob;
    int  chart_len;
    int  i;
    
    Data_Get_Struct( self, StolckeParser, parser );
    rb_ary_getptr( parser->chart_ary, &chart_ptr, &chart_len );
    
    for( i = 0; i < chart_len; ++i ) {
        Data_Get_Struct( chart_ptr[i], StolckeChart, chart );
        sentprob = stolckechart_probability( chart );
        sprintf( buffer, "[#%d] %g\n", i, sentprob );
        rb_io_write( out, rb_str_new2(buffer) );
    }
    
    return self;
}

static VALUE stolcke_parser_display_chart ( VALUE self, VALUE out )
{
    StolckeParser * parser;
    Grammar const * grammar;
    StolckeChart const * schart;
    Chart const * chart;
    State const * state;
    VALUE * chart_ptr;
    VALUE volatile v;
    char  buf [ 4096 ];
    double  sentprob, *inner, *outer;
    int  chart_len;
    int  nonterm;
    int  i, j, k, m;
    
    Data_Get_Struct( self, StolckeParser, parser );
    grammar = parser->grammar;
    rb_ary_getptr( parser->chart_ary, &chart_ptr, &chart_len );
    nonterm = cfg_size_nonterm(grammar);
    inner = ALLOCA_N(double, nonterm);
    outer = ALLOCA_N(double, nonterm);
    
    for( i = 0; i < chart_len; ++i ) {
        Data_Get_Struct( chart_ptr[i], StolckeChart, schart );
        chart = schart->chart;
        v = rb_String(chart->start);
        sprintf( buf, "[StolckeChart:#%p] %s(%d,%d) sentprob=%g\n", schart, RSTRING(v)->ptr, chart->left, chart->right, stolckechart_probability(schart) );
        rb_io_write( out, rb_str_new2(buf) );
        
        sprintf( buf, " - labels ...\n", schart, stolckechart_probability(schart) );
        rb_io_write( out, rb_str_new2(buf) );
        
        for( j = chart->left; j <= chart->right; ++j ) {
            for( k = j; k <= chart->right; ++k ) {
                state = chart_comp(chart, j, k);
                if( state ) {
                    MEMZERO( inner, double, nonterm );
                    MEMZERO( outer, double, nonterm );
                    for( ; state; state = state->next_comp ) {
                        inner[ state->top ] += stolckestate(state)->inner;
                        outer[ state->top ] += stolckestate(state)->outer;
                    }
                    for( m = 1; m < nonterm; ++m ) {
                        if( inner[m] == 0 && outer[m] == 0 )
                            continue;
                        sprintf( buf, "   - %s (%d, %d) : in=%g, out=%g\n", cfg_getcatname(grammar,m), j, k, inner[m], outer[m] );
                        rb_io_write( out, rb_str_new2(buf) );
                    }
                }
            }
        }
        
        sprintf( buf, " - complete state ...\n" );
        rb_io_write( out, rb_str_new2(buf) );
        
        for( j = chart->left; j <= chart->right; ++j ) {
            for( state = chart_dot(chart, j); state; state = state->next_dot ) {
                if( state_complete_p(state) ) {
                    sprintf( buf, "   - %s  <in=%g, out=%g>\n", state_inspect(state, grammar), stolckestate(state)->inner, stolckestate(state)->outer );
                    rb_io_write( out, rb_str_new2(buf) );
                }
            }
        }
        
        sprintf( buf, " - incomplete state ...\n" );
        rb_io_write( out, rb_str_new2(buf) );
        
        for( j = chart->left; j <= chart->right; ++j ) {
            for( state = chart_dot(chart, j); state; state = state->next_dot ) {
                if( !state_complete_p(state) ) {
                    sprintf( buf, "   - %s  <in=%g, out=%g>\n", state_inspect(state, grammar), stolckestate(state)->inner, stolckestate(state)->outer );
                    rb_io_write( out, rb_str_new2(buf) );
                }
            }
        }
    }
    
    return self;
}

static VALUE stolcke_parser_display_parameter ( VALUE self, VALUE out )
{
    StolckeParser * parser;
    StolckeChart * schart;
    Grammar const * grammar;
    Rule const * rule;
    VALUE * chart_ptr;
    double * xtable;
    double  sum, prob, xnum;
    char  buf [ 4096 ];
    char * p;
    int  chart_len;
    int  rulesize, nonterm;
    int  i;
    
    Data_Get_Struct( self, StolckeParser, parser );
    rb_ary_getptr( parser->chart_ary, &chart_ptr, &chart_len );
    grammar = parser->grammar;
    rulesize = cfg_size_rule( grammar );
    nonterm = cfg_size_nonterm( grammar );
    xtable = ALLOCA_ZERO_N( double, rulesize );
    
    /* ғKp񐔂̌vZ */
    for( i = 0; i < chart_len; ++i ) {
        Data_Get_Struct( chart_ptr[i], StolckeChart, schart );
        stolckechart_sum_expectation( schart, xtable );
    }
    
    /* p[^̏o */
    for( i = 1; i < nonterm; ++i ) {
        sum = 0.0;
        for( rule = cfg_hash_lhs(grammar, i); rule; rule = rule->next_lhs )
            sum += xtable[ rule->id ];
        
        if( sum > 0 ) {
            for( rule = cfg_hash_lhs(grammar, i); rule; rule = rule->next_lhs ) {
                xnum = xtable[rule->id];
                prob = xnum / sum;
                
                if( xnum > 0 ) {
                    p = buf;
                    p = rule_typestring_internal(rule, p, -1);
                    p += sprintf( p, " : xtbl=%g, param=%g\n", xnum, prob );
                    rb_io_write( out, rb_str_new2(buf) );
                }
            }
        }
    }
    
    return self;
}

static VALUE stolcke_parser_display_parser ( VALUE self, VALUE out )
{
    StolckeParser * parser;
    Grammar const * grammar;
    char  buf [ 4096 ];
    char * p;
    int  nonterm;
    int  i, cat;
    int  *catptr;
    
    Data_Get_Struct( self, StolckeParser, parser );
    grammar = parser->grammar;
    nonterm = cfg_size_nonterm( grammar );
    
    sprintf( buf, "<#%s:%p>\n", rb_class2name(CLASS_OF(self)), parser );
    rb_io_write( out, rb_str_new2(buf) );
    
    /* sŐV̏ɍXV */
    update_unit_matrix( parser );
    
    for( i = 1; i < nonterm; ++i ) {
        for( catptr = parser->unit_list[i]; *catptr; ++catptr ) {
            cat = *catptr;
            sprintf( buf, "R(%s *=> %s) = %g\n", cfg_getcatname(grammar, i), cfg_getcatname(grammar, cat), stolcke_Ru(parser, i, cat) );
            rb_io_write( out, rb_str_new2(buf) );
        }
    }
    
    return self;
}

static VALUE stolcke_parser_update ( VALUE self, _ProcessOutsideIF processor )
{
    StolckeParser * parser;
    StolckeChart * schart;
    Grammar const * grammar;
    VALUE * chart_ptr;
    double * xtable;
    int  chart_len;
    int  rulesize;
    int  i;
    
    Data_Get_Struct( self, StolckeParser, parser );
    rb_ary_getptr( parser->chart_ary, &chart_ptr, &chart_len );
    grammar = parser->grammar;
    rulesize = cfg_size_rule( grammar );
    xtable = ALLOCA_ZERO_N( double, rulesize );
    
    /* Om̌vZ */
    for( i = 0; i < chart_len; ++i ) {
        Data_Get_Struct( chart_ptr[i], StolckeChart, schart );
        processor( parser, schart );
    }
    
    /* ғKp񐔂̌vZ */
    for( i = 0; i < chart_len; ++i ) {
        Data_Get_Struct( chart_ptr[i], StolckeChart, schart );
        stolckechart_sum_expectation( schart, xtable );
    }
    
    /* m̍XV */
    stolcke_update_ruleprob( parser, xtable );
    
    return self;
}

static void stolcke_parser_outside_init ( StolckeParser * parser, StolckeChart * schart, _PQueuePushIF pusher )
{
    StateQueue * queue = parser->queue;
    Chart * chart = schart->chart;
    State * state;
    int  start;
    
    start = category_int( chart->start );
    
    for( state = chart_comp( chart, chart->left, chart->right ); state; state = state->next_comp ) {
        if( state->top != start )
            continue;
        
        /* d̐Sz͂Ȃ̂ł̂܂ܓo^ */
        pusher( parser, queue, state );
    }
}

static VALUE stolcke_parser_memsize ( VALUE self )
{
    StolckeParser * parser;
    StolckeChart * schart;
    VALUE * ptr;
    int i, len;
    int total = 0;
    
    Data_Get_Struct( self, StolckeParser, parser );
    rb_ary_getptr( parser->chart_ary, &ptr, &len );
    
    for( i = 0; i < len; ++i ) {
        Data_Get_Struct( ptr[i], StolckeChart, schart );
        total += stolcke_chart_memsize( schart );
    }
    
    return rb_fix_new( total );
}


/*   p[UIuWFNg (IWi)
------------------------------------------------------------------- */

static VALUE stolcke_origparser_new ( VALUE klass, VALUE pcfgobj )
{
    return stolcke_parser_new( klass, pcfgobj );
}

static VALUE stolcke_origparser_initialize ( VALUE self, VALUE pcfgobj )
{
    return stolcke_parser_initialize( self, pcfgobj );
}

static VALUE stolcke_origparser_likelihood ( VALUE self )
{
    StolckeParser * parser;
    StolckeChart * schart;
    VALUE * chart_ptr;
    int  chart_len;
    double  sentprob;
    double  likelihood = 0;
    int  i;
    
    Data_Get_Struct( self, StolckeParser, parser );
    rb_ary_getptr( parser->chart_ary, &chart_ptr, &chart_len );
    
    /* R_U g߂ŏ */
    update_unit_matrix( parser );
    
    /* mƖޓx̌vZ */
    for( i = 0; i < chart_len; ++i ) {
        Data_Get_Struct( chart_ptr[i], StolckeChart, schart );
        sentprob = stolcke_origparser_process_inside( parser, schart );
        #if DEBUG_INNER > 0
        fprintf( stderr, "[INNER] inner(#%d) = %g\n", i, sentprob );
        #endif
        likelihood += log( sentprob );
    }
    
    return rb_float_new( likelihood );
}

static VALUE stolcke_origparser_update ( VALUE self )
{
    return stolcke_parser_update( self, &stolcke_origparser_process_outside );
}

static void stolcke_origparser_scanning ( StolckeParser * parser, StolckeChart * schart, int pos )
{
    Chart * chart = schart->chart;
    Rule const * rule;
    State * prev;
    State * ptr;
    int  left, dot, wait;
    
    /* pos .. pos+1 ɏI[L݂ƂďĂ܂ */
    for( ptr = chart_dot(chart, pos); ptr; ptr = ptr->next_dot ) {
        /* hbgi񂾂̂ΏۂƂ */
        rule = ptr->rule;
        if( !rule || ptr->dot <= 0 )
            continue;
        
        /* OI[L̏ꍇ̂ݍl */
        left = ptr->left;
        dot = ptr->dot - 1;
        wait = rule->rhs[ dot ];
        if( wait > 0 )
            continue;
        
        /* iޑȌԂĂ */
        for( prev = chart_rwait(chart, wait, ptr->right-1); prev; prev = prev->next_rwait ) {
            if( prev->rule == rule && prev->left == left && prev->dot == dot ) {
                #if DEBUG_SCANNING > 0
                fprintf( stderr, "[SCAN] %s (%g)\n", state_inspect(prev, parser->grammar), stolckestate(prev)->inner );
                fprintf( stderr, "   --> %s\n", state_inspect(ptr, parser->grammar) );
                #endif
                stolckestate(ptr)->inner = stolckestate(prev)->inner;
            }
        }
        
        /* ł΃L[ɒǉ (dĐ邱Ƃ͂Ȃ̂ő݃`FbN͖) */
        if( state_complete_p(ptr) )
            pqueue_push_inside( parser->queue, ptr );
    }
}

static void stolcke_origparser_completion ( StolckeParser * parser, StolckeChart * schart )
{
    StateQueue * queue = parser->queue;
    Chart * chart = schart->chart;
    State_p state, qstate, wstate;
    double  ru;
    int  wait, nonterm;
    
    nonterm = cfg_size_nonterm(parser->grammar);
    while( qstate = queue_shift( queue ) ) {
        #if DEBUG_COMPLETION > 0
        fprintf( stderr, "[COMP] %s (%g)\n", state_inspect(qstate, parser->grammar), stolckestate(qstate)->inner );
        #endif
        
        /* qstate ̃gbvɍsLl */
        for( wait = 1; wait < nonterm; ++wait ) {
            ru = stolcke_Ru(parser, wait, qstate->top);
            if( ru == 0 )
                continue;
            
            for( wstate = chart_rwait(chart, wait, qstate->left); wstate; wstate = wstate->next_rwait ) {
                /* hbgi񂾍 */
                state = chart_find_state( chart, wstate->rule, wstate->left, qstate->right, wstate->dot + 1 );
                if( !state )
                    continue;
                
                /* hbgi񂾐̍vZ */
                stolckestate(state)->inner += stolckestate(wstate)->inner * stolckestate(qstate)->inner * ru;
                #if DEBUG_COMPLETION > 0
                fprintf( stderr, "      + %s (%g)\n", state_inspect(wstate, parser->grammar), stolckestate(wstate)->inner );
                fprintf( stderr, "    --> %s (%g)\n", state_inspect(state, parser->grammar), stolckestate(state)->inner );
                fprintf( stderr, "       (ru=%g)\n", ru );
                #endif
                
                /* uԁvuEӋL傫vȂΉ߂ */
                if( state_complete_p(state) && state->rule->rhslen > 1 ) {
                    /* dĂꍇ͓o^Ȃ */
                    if( !queue_find_equal( queue, state ) )
                        pqueue_push_inside( queue, state );
                }
            }
        }
    }
}

static double stolcke_origparser_process_inside ( StolckeParser * parser, StolckeChart * schart )
{
    Chart * chart = schart->chart;
    int  i;
    
    /* m̏ */
    stolckechart_init_inner( schart );
    
    /* ܂ Prediction ƓƂs (hbgʒu 0 ̂̂̓mC) */
    stolckechart_prediction( parser, schart );
    
    /* vZJn */
    for( i = 0; i < chart->len; ++i ) {
        /* Scanning */
        stolcke_origparser_scanning( parser, schart, i );
        
        /* Completion */
        stolcke_origparser_completion( parser, schart );
    }
    
    /* Jn̊mv */
    return stolckechart_probability( schart );
}

static void stolcke_origparser_outside_init ( StolckeParser * parser, StolckeChart * schart )
{
    stolcke_parser_outside_init( parser, schart, &pqueue_push_outside_original );
}

static void stolcke_origparser_reverse_completion ( StolckeParser * parser, StolckeChart * schart, State * qstate )
{
    StateQueue localqueue, *queue;
    State * * state_buffer;
    Chart * chart = schart->chart;
    State_p  state, wstate, cstate;
    Rule const * rule;
    int  state_capacity;
    int  nonterm;
    int  cat, wait, waitdot, count;
    double  ru;
    
    if( !qstate->rule )
        return; /* I[Ԃ͂ǂɂłȂ */
    
    state_capacity = (qstate->right - qstate->left) * 2; /* 傫߂ɊmۂĂ */
    state_buffer = ALLOCA_N(State*, state_capacity);
    queue = queue_init_prepared( &localqueue, state_buffer, state_capacity );
    nonterm = cfg_size_nonterm(parser->grammar);
    
    /* ܂͊ԂL[ɓo^Ă */
    queue_push( queue, qstate );
    
    while( state = queue_shift( queue ) ) {
        #if DEBUG_RCOMPLETION > 1
        fprintf( stderr, "[RCMP] %s (out=%g)\n", state_inspect(state, parser->grammar), stolckestate(qstate)->outer );
        #endif
        
        /* hbgʒu擪̏ꍇ͉Ȃ (łȂ) */
        if( state->dot == 0 )
            continue;
        
        rule = state->rule;
        waitdot = state->dot - 1;
        wait = rule->rhs[ waitdot ];
        if( wait < 0 ) {
            /* I[L̏ꍇ */
            wstate = chart_find_state( chart, state->rule, state->left, state->right - 1, state->dot - 1 );
            stolckestate(wstate)->outer += stolckestate(state)->outer;
            queue_push( queue, wstate ); /* d邱Ƃ͂蓾Ȃ */
        }
        else {
            /* I[L̏ꍇ */
            for( wstate = chart_lwait(chart, wait, state->left); wstate; wstate = wstate->next_lwait ) {
                /* ܂̓hbg߂Ԃ */
                if( wstate->rule != rule || wstate->dot != waitdot || wstate->right >= state->right )
                    continue; /* sKi */
                
                /* wstate  state ̊Ԃɑ݂Ԃ */
                count = 0;
                for( cat = 1; cat < nonterm; ++cat ) {
                    ru = stolcke_Ru( parser, wait, cat );
                    if( ru == 0.0 )
                        continue; /*$ 0.0 łȂCfNX̃XgpӂĂ΂ƑȂ $*/
                    
                    for( cstate = chart_comp(chart, wstate->right, state->right); cstate; cstate = cstate->next_comp ) {
                        if( cstate->top != cat )
                            continue; /* TĂ̂Ɩ֌W */
                        
                        /* Om̌vZ */
                        ++count;
                        stolckestate(cstate)->outer += stolckestate(wstate)->inner * stolckestate(state)->outer * ru;
                        stolckestate(wstate)->outer += stolckestate(cstate)->inner * stolckestate(state)->outer;
                        
                        #if DEBUG_RCOMPLETION > 1
                        fprintf( stderr, "   --> %s (out=%g)\n", state_inspect(wstate, parser->grammar), stolckestate(wstate)->outer );
                        fprintf( stderr, "     + %s (out=%g)\n", state_inspect(cstate, parser->grammar), stolckestate(cstate)->outer );
                        #endif
                        
                        if( cstate->rule && cstate->rule->rhslen > 1 ) {
                            /* unit-production ̓L[ɓȂ */
                            if( !queue_find_equal( parser->queue, cstate ) )
                                pqueue_push_outside_original( parser, parser->queue, cstate );
                        }
                    }
                }
                
                /* wstate gpĂ΃L[ɒǉ */
                if( count > 0 ) {
                    if( !queue_find_equal( queue, wstate ) )
                        queue_push( queue, wstate );
                }
            }
        }
    }
    
    queue_free_internal( queue );
}

static void stolcke_origparser_process_outside ( StolckeParser * parser, StolckeChart * schart )
{
    StateQueue * queue = parser->queue;
    State * state;
    
    /* m̏ */
    stolckechart_init_outer( schart );
    
    /* L[ɏIԂ߂ */
    stolcke_origparser_outside_init( parser, schart );
    
    /* Reverse Completion */
    while( state = queue_shift( queue ) ) {
        #if DEBUG_RCOMPLETION > 0
        fprintf( stderr, "[RCMP-QUEUE] %s\n", state_inspect(state, parser->grammar) );
        #endif
        stolcke_origparser_reverse_completion( parser, schart, state );
    }
}


/*   p[UIuWFNg (CE[JL[)
------------------------------------------------------------------- */

static VALUE stolcke_flqparser_new ( VALUE klass, VALUE pcfgobj )
{
    return stolcke_parser_new( klass, pcfgobj );
}

static VALUE stolcke_flqparser_initialize ( VALUE self, VALUE pcfgobj )
{
    VALUE volatile obj;
    StolckeParser * parser;
    
    obj = stolcke_parser_initialize( self, pcfgobj );
    Data_Get_Struct( obj, StolckeParser, parser );
    
    return obj;
}

static VALUE stolcke_flqparser_update ( VALUE self )
{
    return stolcke_parser_update( self, &stolcke_flqparser_process_outside );
}

static void stolcke_flqparser_outside_init ( StolckeParser * parser, StolckeChart * schart )
{
    stolcke_parser_outside_init( parser, schart, &pqueue_push_outside_flq );
}

static void stolcke_flqparser_unit_state_outside ( StolckeParser * parser, StolckeChart * schart, State * ustate )
{
    Rule const * rule = ustate->rule;
    Chart * chart = schart->chart;
    int  left = ustate->left;
    int  right = ustate->right;
    
    State_p  state, cstate;
    double  inner;
    int  top;
    
    top = rule->rhs[0];
    for( state = chart_lwait( chart, top, left ); state; state = state->next_lwait ) {
        if( state->dot != 0 || state->rule != rule )
            continue;
        
        inner = 0.0;
        for( cstate = chart_comp( chart, left, right ); cstate; cstate = cstate->next_comp ) {
            if( cstate->top != top )
                continue;
            inner += stolckestate(cstate)->inner;
        }
        stolckestate(state)->outer += stolckestate(ustate)->outer * inner;
    }
}

static void stolcke_flqparser_state_outside ( StolckeParser * parser, StolckeChart * schart, StateQueue * localqueue )
{
    Chart * chart = schart->chart;
    int  nonterm = cfg_size_nonterm( parser->grammar );
    Rule const * rule;
    State_p  state, wstate, cstate;
    int  cat, count, waitdot, wait, *catptr;
    double ru, state_outer;
    
    /* Ԃ̑S\vf𕪉܂ő */
    while( state = queue_shift( localqueue ) ) {
        #if DEBUG_RCOMPLETION > 1
        DEBUG_display_state( "[RCMP]", parser, state );
        #endif
        
        /* hbgʒu擪̏ꍇ͉Ȃ (łȂ) */
        if( state->dot == 0 )
            continue;
        
        rule = state->rule;
        waitdot = state->dot - 1;
        wait = rule->rhs[ waitdot ];
        state_outer = stolckestate(state)->outer;
        if( wait < 0 ) {
            /* I[L̏ꍇ */
            wstate = chart_find_state( chart, state->rule, state->left, state->right - 1, state->dot - 1 );
            if( !wstate )
                rb_raise( rb_eRuntimeError, "Earley chart broken (1)" );
            stolckestate(wstate)->outer = state_outer; /* I[L inner  1 */
            queue_push( localqueue, wstate ); /* d邱Ƃ͂蓾Ȃ̂Ń`FbN */
        }
        else {
            /* I[L̏ꍇ: wstate = <X> -->  * <Z>  */
            for( wstate = chart_lwait(chart, wait, state->left); wstate; wstate = wstate->next_lwait ) {
                /* ܂̓hbg߂Ԃ */
                if( wstate->rule != rule || wstate->dot != waitdot || wstate->right >= state->right )
                    continue; /* sKi */
                
                /* wstate  state ̊Ԃɑ݂Ԃ */
                count = 0;
                for( catptr = stolcke_Ru_list(parser, wait); *catptr; ++catptr ) {
                    /* R(Z *=> Y) > 0  <Y> -->  *  */
                    cat = *catptr;
                    ru = stolcke_Ru( parser, wait, cat );
                    
                    for( cstate = chart_comp(chart, wstate->right, state->right); cstate; cstate = cstate->next_comp ) {
                        /* wstate  state ɂԂ */
                        if( cstate->top != cat )
                            continue; /* TĂ̂Ɩ֌W */
                        
                        ++count;
                        if( cstate->rule && cstate->rule->rhslen == 1 && cstate->rule->rhs[0] > 0 ) {
                            /*  = <A> */
                            stolckestate(cstate)->outer += state_outer * stolckestate(wstate)->inner * ru;
                        }
                        else {
                            /*  = <A> <B> ... */
                            stolckestate(cstate)->outer += state_outer * stolckestate(wstate)->inner * ru;
                            stolckestate(wstate)->outer += state_outer * ru * stolckestate(cstate)->inner;
                        }
                        if( !queue_find_equal( parser->queue, cstate ) ) {
                            #if DEBUG_RCOMPLETION > 1
                            DEBUG_display_state( "(c) + ", parser, cstate );
                            #endif
                            pqueue_push_outside_flq( parser, parser->queue, cstate );
                        }
                    }
                }
                
                /* wstate gpĂ΃L[ɒǉ */
                if( count > 0 ) {
                    if( !queue_find_equal( localqueue, wstate ) ) {
                        #if DEBUG_RCOMPLETION > 1
                        DEBUG_display_state( "(w) + ", parser, wstate );
                        #endif
                        queue_push( localqueue, wstate );
                    }
                }
            }
        }
    }
}

static void stolcke_flqparser_reverse_completion ( StolckeParser * parser, StolckeChart * schart, StateQueue * localqueue, State * qstate )
{
    Rule const * rule = qstate->rule;
    
    /* I[Ԃ͂ǂɂłȂ */
    if( !rule )
        return;
    
    /* gbvȊO <X> --> <A> ^Cv̏Ԃ */
    if( rule->rhslen == 1 && rule->rhs[0] > 0 && (qstate->tag & TAG_TopItem) == 0 ) {
        stolcke_flqparser_unit_state_outside( parser, schart, qstate );
        return;
    }
    
    /* ܂ԂL[ɓo^ĂvZJn */
    queue_push( localqueue, qstate );
    stolcke_flqparser_state_outside( parser, schart, localqueue );
}

static void stolcke_flqparser_process_outside ( StolckeParser * parser, StolckeChart * schart )
{
    StateQueue  localqueue;
    State * * state_buffer;
    State * state;
    int  state_capacity;
    
    /* [JL[̍쐬 */
    state_capacity = (schart->chart->right - schart->chart->left) * 2; /* 傫߂ɊmۂĂ */
    state_buffer = ALLOCA_N(State*, state_capacity);
    queue_init_prepared( &localqueue, state_buffer, state_capacity );
    
    /* m̏ */
    stolckechart_init_outer( schart );
    
    /* L[ɏIԂ߂ */
    stolcke_flqparser_outside_init( parser, schart );
    
    /* Reverse Completion */
    while( state = queue_shift( parser->queue ) ) {
        #if DEBUG_RCOMPLETION > 0
        DEBUG_display_state( "[RCMP-QUEUE]", parser, state );
        #endif
        stolcke_flqparser_reverse_completion( parser, schart, &localqueue, state );
    }
    
    /* [JL[̉ */
    queue_free_internal( &localqueue );
}


/*   p[UIuWFNg (C)
------------------------------------------------------------------- */

static VALUE stolcke_fixedparser_new ( VALUE klass, VALUE pcfgobj )
{
    return stolcke_parser_new( klass, pcfgobj );
}

static VALUE stolcke_fixedparser_initialize ( VALUE self, VALUE pcfgobj )
{
    VALUE volatile obj;
    StolckeParser * parser;
    int  nonterm;
    
    obj = stolcke_parser_initialize( self, pcfgobj );
    Data_Get_Struct( obj, StolckeParser, parser );
    nonterm = cfg_size_nonterm( parser->grammar );
    
    return obj;
}

static VALUE stolcke_fixedparser_likelihood ( VALUE self )
{
    return stolcke_origparser_likelihood( self ); /* m̌vZ͏CłIWił */
}

static VALUE stolcke_fixedparser_update ( VALUE self )
{
    return stolcke_parser_update( self, &stolcke_fixedparser_process_outside );
}

static void stolcke_fixedparser_outside_init ( StolckeParser * parser, StolckeChart * schart )
{
    stolcke_parser_outside_init( parser, schart, &pqueue_push_outside_fixed );
}

static void stolcke_fixedparser_unit_state_outside ( StolckeParser * parser, StolckeChart * schart, State * ustate )
{
    Rule const * rule = ustate->rule;
    Chart * chart = schart->chart;
    int  left = ustate->left;
    int  right = ustate->right;
    
    State_p  state, cstate;
    double  inner;
    int  top;
    
    top = rule->rhs[0];
    for( state = chart_lwait( chart, top, left ); state; state = state->next_lwait ) {
        if( state->dot != 0 || state->rule != rule )
            continue;
        
        inner = 0.0;
        for( cstate = chart_comp( chart, left, right ); cstate; cstate = cstate->next_comp ) {
            if( cstate->top != top )
                continue;
            inner += stolckestate(cstate)->inner;
        }
        stolckestate(state)->outer += stolckestate(ustate)->outer * inner;
    }
}

static void stolcke_fixedparser_reverse_completion ( StolckeParser * parser, StolckeChart * schart, State * state )
{
    Chart * chart = schart->chart;
    Rule const * rule = state->rule;
    double state_outer = stolckestate(state)->outer;
    int waitdot = state->dot - 1;
    int wait = rule->rhs[ state->dot - 1 ];
    
    StateQueue * queue = parser->queue;
    State_p  wstate, cstate;
    double  ru, inner;
    
    if( wait < 0 ) {
        /* I[L̏ꍇ */
        wstate = chart_find_state( chart, state->rule, state->left, state->right - 1, state->dot - 1 );
        if( !wstate )
            rb_raise( rb_eRuntimeError, "Earley chart broken (1)" );
        stolckestate(wstate)->outer = state_outer; /* I[L inner  1 */
        pqueue_push_outside_fixed( parser, queue, wstate ); /* d邱Ƃ͂蓾Ȃ̂Ń`FbN */
        #if DEBUG_RCOMPLETION > 1
        DEBUG_display_state( "(w) + ", parser, wstate );
        #endif
    }
    else {
        /* I[L̏ꍇ: wstate = <X> -->  * <Z>  */
        for( wstate = chart_lwait(chart, wait, state->left); wstate; wstate = wstate->next_lwait ) {
            /* ܂̓hbg߂Ԃ */
            if( wstate->rule != rule || wstate->dot != waitdot || wstate->right >= state->right )
                continue; /* sKi */
            
            /* wstate  state ̊Ԃɑ݂Ԃ */
            inner = 0.0;
            for( cstate = chart_comp(chart, wstate->right, state->right); cstate; cstate = cstate->next_comp ) {
                ru = stolcke_Ru( parser, wait, cstate->top );
                if( ru == 0.0 )
                    continue;
                
                stolckestate(cstate)->outer += stolckestate(wstate)->inner * state_outer * ru;
                if( !queue_find_equal( queue, cstate ) ) {
                    #if DEBUG_RCOMPLETION > 1
                    DEBUG_display_state( "(c) + ", parser, cstate );
                    #endif
                    pqueue_push_outside_fixed( parser, queue, cstate );
                }
                
                if( !cstate->rule || cstate->rule->rhslen > 1 || cstate->rule->rhs[0] < 0 )
                    inner += stolckestate(cstate)->inner * ru;
            }
            if( inner == 0 )
                continue; /* wstate ͎gȂ̂ */
            
            stolckestate(wstate)->outer += inner * state_outer;
            if( !queue_find_equal( queue, wstate ) ) {
                #if DEBUG_RCOMPLETION > 1
                DEBUG_display_state( "(w) + ", parser, wstate );
                #endif
                pqueue_push_outside_fixed( parser, queue, wstate );
            }
        }
    }
}

static void stolcke_fixedparser_process_outside ( StolckeParser * parser, StolckeChart * schart )
{
    Rule const * rule;
    State * state;
    
    /* m̏ */
    stolckechart_init_outer( schart );
    
    /* L[ɏIԂ߂ */
    stolcke_fixedparser_outside_init( parser, schart );
    
    /* Reverse Completion */
    while( state = queue_shift( parser->queue ) ) {
        #if DEBUG_RCOMPLETION > 0
        DEBUG_display_state( "[RCMP-QUEUE]", parser, state );
        #endif
        
        /* I[Ԃ͂ǂɂłȂ */
        rule = state->rule;
        if( !rule )
            continue;
        
        /* hbgʒu 0 ̂̂͂ǂɂłȂ */
        if( state->dot == 0 )
            continue;
        
        /* gbvȊO <X> --> <A> ^Cv̏Ԃ */
        if( rule->rhslen == 1 && rule->rhs[0] > 0 && (state->tag & TAG_TopItem) == 0 ) {
            /* hbgʒu 0 ȊOŉEӒ 1 ȂΎIɃhbgʒu 1 ɂȂ */
            stolcke_fixedparser_unit_state_outside( parser, schart, state );
            continue;
        }
        
        /* Ԃ̕ */
        stolcke_fixedparser_reverse_completion( parser, schart, state );
        #if DEBUG_PQUEUE > 0
        pqueue_display( stderr, parser->queue, parser );
        #endif
    }
}


/*   W[̏
------------------------------------------------------------------- */

void init_stolcke ( void )
{
    VALUE volatile cls_Stolcke;
    
    /* Stolcke W[̒`: ̃W[̉Ƀp[UȂǂ` */
    cls_Stolcke = rb_define_module_under( rb_mExt, "Stolcke" );
    
    /* Parser NX̒`: p[ŮNX */
    cls_Stolcke_Parser = rb_define_class_under( cls_Stolcke, "Parser", rb_cData );
    
    /* Chart NX̒`: mvZp̃f[^̈m */
    cls_Stolcke_Chart = rb_define_class_under( cls_Stolcke, "Chart", rb_cData );
    
    /* OriginalParser NX̒`: Stolcke _ɊÂčČ */
    cls_Stolcke_OriginalParser = rb_define_class_under( cls_Stolcke, "OriginalParser", cls_Stolcke_Parser );
    
    /* FLQParser NX̒`: _C */
    cls_Stolcke_FLQParser = rb_define_class_under( cls_Stolcke, "FLQParser", cls_Stolcke_Parser );
    
    /* FixedParser NX̒`: _C */
    cls_Stolcke_FixedParser = rb_define_class_under( cls_Stolcke, "FixedParser", cls_Stolcke_Parser );
    
    /* (Parser) \bh̒` */
    rb_define_method( cls_Stolcke_Parser, "store", stolcke_parser_store, 1 );
    rb_define_method( cls_Stolcke_Parser, "likelihood", stolcke_parser_likelihood_m, 0 );
    rb_define_method( cls_Stolcke_Parser, "update", stolcke_parser_update_m, 0 );
    rb_define_method( cls_Stolcke_Parser, "get_parameter", stolcke_parser_get_parameter, 0 );
    rb_define_method( cls_Stolcke_Parser, "display_inside", stolcke_parser_display_inside, 1 );
    rb_define_method( cls_Stolcke_Parser, "display_chart", stolcke_parser_display_chart, 1 );
    rb_define_method( cls_Stolcke_Parser, "display_parameter", stolcke_parser_display_parameter, 1 );
    rb_define_method( cls_Stolcke_Parser, "display_parser", stolcke_parser_display_parser, 1 );
    rb_define_method( cls_Stolcke_Parser, "memsize", stolcke_parser_memsize, 0 );
    
    /* (OriginalParser) \bh̒` */
    rb_define_singleton_method( cls_Stolcke_OriginalParser, "new", stolcke_origparser_new, 1 );
    
    rb_define_method( cls_Stolcke_OriginalParser, "initialize", stolcke_origparser_initialize, 1 );
    rb_define_method( cls_Stolcke_OriginalParser, "likelihood", stolcke_origparser_likelihood, 0 );
    rb_define_method( cls_Stolcke_OriginalParser, "update", stolcke_origparser_update, 0 );
    
    #ifdef ENABLED_pqueue_inside_test
    rb_define_method( cls_Stolcke_OriginalParser, "pqueue_inside_test", stolcke_pqueue_inside_test, 0 );
    #endif
    
    /* (FLQParser) \bh̒` */
    rb_define_singleton_method( cls_Stolcke_FLQParser, "new", stolcke_fixedparser_new, 1 );
    
    rb_define_method( cls_Stolcke_FLQParser, "initialize", stolcke_fixedparser_initialize, 1 );
    rb_define_method( cls_Stolcke_FLQParser, "likelihood", stolcke_fixedparser_likelihood, 0 );
    rb_define_method( cls_Stolcke_FLQParser, "update", stolcke_flqparser_update, 0 );
    
    /* (FixedParser) \bh̒` */
    rb_define_singleton_method( cls_Stolcke_FixedParser, "new", stolcke_fixedparser_new, 1 );
    
    rb_define_method( cls_Stolcke_FixedParser, "initialize", stolcke_fixedparser_initialize, 1 );
    rb_define_method( cls_Stolcke_FixedParser, "likelihood", stolcke_fixedparser_likelihood, 0 );
    rb_define_method( cls_Stolcke_FixedParser, "update", stolcke_fixedparser_update, 0 );
}

