/*                                                     project Gemini 
----------------------------------------------------------------------
    Stolcke ̃ASY
      $Id: stolcke.h,v 1.2 2002/11/22 03:00:45 abe Exp $

       Copyright (C) 2001-2002, SATO Lab. <http://mi.cs.titech.ac.jp> 
----------------------------------------------------------------------
*/
/** @file
 * @brief Stolcke ̃ASY (wb_)
 *
 * Stolcke ̃ASYɊւ@\`܂B
 * 
 * @author ABE Shigeru
 * @date 2002/10/29
 * $Revision: 1.2 $
 */
#ifndef _STOLCKE_H_20021029Tue_171214_
#define _STOLCKE_H_20021029Tue_171214_

#include "nlputil.h"


/** @brief Stolcke p[UIuWFNg ()
 *
 * Ext::Stolcke::Parser \ Ruby ̃NXIuWFNg܂B
 */
extern VALUE cls_Stolcke_Parser;


/** @brief Stolcke `[gIuWFNg
 *
 * Ext::Stolcke::Chart \ Ruby ̃NXIuWFNg܂B
 */
extern VALUE cls_Stolcke_Chart;


/** @brief Stolcke p[UIuWFNg (IWiEASY)
 *
 * Ext::Stolcke::OriginalParser \ Ruby ̃NXIuWFNg܂B
 */
extern VALUE cls_Stolcke_OriginalParser;


/** @brief Stolcke p[UIuWFNg (CE[JL[)
 *
 * Ext::Stolcke::FLQParser \ Ruby ̃NXIuWFNg܂B
 */
extern VALUE cls_Stolcke_FLQParser;


/** @brief Stolcke p[UIuWFNg (C)
 *
 * Ext::Stolcke::FixedParser \ Ruby ̃NXIuWFNg܂B
 */
extern VALUE cls_Stolcke_FixedParser;


/** @brief m Earley 
 *
 * Earley ԂɊm邽߂́AState pǉf[^łB
 */
struct tagStolckeState
{
    /** @brief m
     *
     * ̏ԂɑΉm܂B
     */
    double  inner;
    
    /** @brief Om
     *
     * ̏ԂɑΉOm܂B
     */
    double  outer;
};
typedef  struct tagStolckeState  StolckeState; /**< m Earley  */


/** @brief Earley `[g
 *
 * StolckeState ێĂ߂̃`[głB
 */
struct tagStolckeChart
{
    /** @brief ƂȂĂ`[g
     *
     * ̃`[g\ẑɎgꂽ`[gIuWFNg܂B
     */
    Chart*  chart;
    
    /** @brief ǉf[^pobt@
     *
     * ̃`[gŎgĂA State ̒ǉf[^SĂێĂ߂̃obt@łB
     */
    StolckeState*  state_buffer;
};
typedef  struct tagStolckeChart  StolckeChart; /**< Earley `[g */


/** @brief Stolcke ̃ASY
 *
 * Stolcke ĂASỸp[UɑΉIuWFNgłB
 */
struct tagStolckeParser
{
    /** @brief Ruby IuWFNg
     *
     * gɑΉ Ruby IuWFNg܂B
     */
    VALUE ruby_object;
    
    /** @brief @
     *
     * ̃p[Ugp镶@IuWFNg܂B
     */
    Grammar*  grammar;
    
    /** @brief Km̃e[u
     *
     * @KɊ蓖Ăꂽmi[邽߂̃e[ułB
     * EM wKɂāAe[u̒l͏Ă܂B
     * TCY cfg_size_rule(grammar) ɂȂ܂B
     */
    double * prob_table;
    
    /** @brief Pꐶs
     *
     * R_U słB
     * TCY͏c cfg_size_nonterm(grammar) ɂȂ܂B
     */
    double * * unit_matrix;
    
    /** @brief LȒPꐶsZ̃Xg
     *
     * unit_matrix ̂A0 ȊO̒lݒ肳Ăӏ̃Xg܂B
     * eCfNXȉ 0 ŏI int ̔zɂȂĂACfNXsA
     * z̒lƂƁAunit_matrix őΉʒu 0 ȊOɂȂ܂B
     */
    int * * unit_list;
    
    /** @brief o^Ă`[g̃Xg
     *
     * EM wKŎgp`[gIuWFNgێ܂B
     */
    VALUE  chart_ary;
    
    /** @brief DxtL[
     *
     * \͂ŎgL[łB
     * gꏊɉāA̖ڂς܂B
     */
    StateQueue * queue;
};
typedef  struct tagStolckeParser  StolckeParser; /**< Stolcke ̃ASY */


/** @brief W[̏
 *
 * Stolcke p[UɊւ鏉s܂B
 */
void init_stolcke ( void );


/*   vg^Cv
------------------------------------------------------------------- */

/** @brief PꐶsvZ
 *
 * ^ꂽ Stolcke p[UIuWFNg̒PꐶsvZ܂B
 * ̊֐Ăяo_̋KmŌvZs܂B
 * 
 * ܂Pꐶsp̃̈悪mۂĂȂꍇ́AIɊmۂ܂B
 *
 * @param parser [i/o] Stolcke p[UIuWFNg
 * @return nꂽ parser IuWFNg
 */
StolckeParser* update_unit_matrix ( StolckeParser* parser );

/** @brief Kme[u쐬
 *
 * ^ꂽ PCFG AKm̃e[u쐬܂B
 * Ԃe[u ruby_xfree() ŉsĂB
 *
 * @param pcfg [in] PCFG IuWFNg
 * @return me[u
 */
double * create_prob_table ( PCFG* pcfg );

/** @brief p[U̐ (ʌ`)
 *
 * w肳ꂽ PCFG IuWFNgg Stolcke p[U𐶐܂B
 * ۂɐp[UIuWFNg klass ɂĕς܂B
 * ̂߁Ap[UIuWFNg[`̋ʕɂȂ܂B
 *
 * @param klass [in] p[ŨNX\IuWFNg
 * @param pcfgobj [in] KƊm̏l
 * @return p[UIuWFNg
 */
VALUE stolcke_parser_new ( VALUE klass, VALUE pcfgobj );

/** @brief `[g̐
 *
 * ^ꂽ\͌ʂgāA`[g𐶐܂B
 * itemset ̎Ă镶@ƁA parser Ă镶@́ÃIuWFNgłȂ΂Ȃ܂B
 * قȂ@^ꂽꍇ RuntimeError O܂B
 *
 * @param parser [in] Stolcke p[UIuWFNg
 * @param itemset [in] ƂȂ\͌
 * @return ꂽ`[gIuWFNg
 */
VALUE stolcke_origchart_new ( StolckeParser* parser, ItemSet const * itemset );

/** @brief `[g̃}[N
 *
 * Kx[WRN^p̃}[NƂs܂B
 *
 * @param ptr [i/o] ΏۂƂȂ`[gIuWFNg
 */
void stolckechart_mark ( StolckeChart* ptr );

/** @brief `[g̐m擾
 *
 * w肳ꂽ`[g̐m擾܂B
 * JnLgbvɎAŜ𒣂ꂽԂ̓mɑ΂鑍aƂȂ܂B
 *
 * @param schart [in] `[g
 * @return m
 */
double stolckechart_probability ( StolckeChart const * schart );

/*   }N
------------------------------------------------------------------- */

/** @brief R_U ̒l擾
 *
 * PꐶKɊւs񂩂Aw肳ꂽŒl擾܂B
 *
 * @param PARSERPTR [in] (StolckeParser*) p[UIuWFNg
 * @param LEFT [in] (int) Jڌ̋L
 * @param RIGHT [in] (int) Jڐ̋L
 * @return R_U ̒l (double)
 */
#define stolcke_Ru(PARSERPTR,LEFT,RIGHT)  ((PARSERPTR)->unit_matrix[LEFT][RIGHT])

/** @brief R_U ̍sXg擾
 *
 * PꐶKɊւs񂩂Aw肳ꂽŝ 0 ȊO̗vfłʒuXg擾܂B
 *
 * @param PARSERPTR [in] (StolckeParser*) p[UIuWFNg
 * @param LINE [in] (int) 擾s
 * @return 0 I[ƂʒuXg (int*)
 */
#define stolcke_Ru_list(PARSERPTR,LINE)  ((PARSERPTR)->unit_list[LINE])

/** @brief mf[^̎擾
 *
 * ԂɊ蓖Ăꂽ StolckeState ւ̃|C^擾܂B
 * nԂ́Af[^Ƃ StolckeState Ă̂Ƃ܂B
 *
 * @param STATEPTR [in] (State*) ԃIuWFNg
 * @return mf[^ւ̎Q (StolckeState*)
 */
#define stolckestate(STATEPTR)  ((StolckeState*)((STATEPTR)->data))


#endif /* _STOLCKE_H_20021029Tue_171214_ */
